/*
 * OZ711MS1 OZ711MP1 linux driver
 * O2Micro Inc.
 * toby.yang@o2micro.com
 * 2005/4/17
   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2 of the License, or
   (at your option) any later version.
   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.
   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/
#include "base.h"
unsigned long pci_rDword(_PCI_CONTEXT PciDevice, unsigned long wOffset)
{
	unsigned int ret=0;
	pci_read_config_dword(PciDevice,wOffset,&ret);
	return ret;	
}
void pci_wDword(_PCI_CONTEXT PciDevice, unsigned long wOffset, unsigned long Data)
{
	pci_write_config_dword(PciDevice,wOffset,Data);
}

///--------------------------------------------------------
unsigned long  mem_rDword(unsigned long* address)
{
//	printk("read dword %x\n",address);
	return readl(address);
}
unsigned short mem_rWord (unsigned short* address)
{
//	printk("read word %x\n",address);
	return readw(address);
}
unsigned char  mem_rByte (unsigned char* address)
{
//	printk("read byte %x\n",address);
	return readb(address);
}

void    mem_wDword(unsigned long* address, unsigned long dwData)
{
//	printk("write dword %x,%x\n",address,dwData);
	writel(dwData,address);
}
void    mem_wWord (unsigned short* address, unsigned short wData)
{
//	printk("write word %x,%x\n",address,wData);
	writew(wData,address);
}
void    mem_wByte (unsigned char* address, unsigned char bData)
{
//	printk("write byte %x,%x\n",address,bData);
	writeb(bData,address);
}

static void DelayMicroSecond(unsigned long MicroSecond)
{
	while( 1 )
	{
		if( MicroSecond <= 0 )
			break;

		if( MicroSecond < 1000 )

		{
			udelay( MicroSecond );
			MicroSecond = 0;
		}
		else
		{	
			udelay( 1000 );

			MicroSecond = MicroSecond - 1000;
		}

	}
	return;
}
void _SysDelayMicroS( unsigned long Timeout )
{
	// if( KeGetCurrentIrql() >= DISPATCH_LEVEL ) {
	// ULONG	Cnt = 20 * Timeout;
	unsigned long temp;

	if (Timeout > 1) {
		Timeout --;
	}
	do {
		if( Timeout > 20 )
		{
			Timeout -= 20;
			temp = 20;
		}
		else
		{
			temp = Timeout;
			Timeout = 0;
		}

		DelayMicroSecond(temp);

	} while (Timeout != 0);
	return;
}

/*
SysDelay : Delay function! Unit : milli-second
*/
void SysDelay( unsigned long Timeout)
{
	_SysDelayMicroS(Timeout*1000);
	return;
}

void SysDelayMicroS( unsigned long Timeout )
{
	_SysDelayMicroS(Timeout);
	return;
}


#if LINUX_VERSION_CODE <  KERNEL_VERSION(2,4,0)
static struct wait_queue *o2media_Event = NULL;
static struct wait_queue *o2media_timerint_event = NULL;
#else
DECLARE_WAIT_QUEUE_HEAD(o2media_Event);
DECLARE_WAIT_QUEUE_HEAD(o2media_timerint_event);
#endif
static spinlock_t o2media_intr_lock = SPIN_LOCK_UNLOCKED;
static spinlock_t o2media_timerint_lock = SPIN_LOCK_UNLOCKED;
static UCHAR o2media_intr_comming = 0;
static UCHAR o2media_timerint = 0;
static DECLARE_COMPLETION(ko2media_exited);
void o2media_wait_event_interruptible(void)
{
	wait_event_interruptible(o2media_Event,o2media_intr_comming);
}
void o2media_wait_timerint_event_interruptible(void)
{
	wait_event_interruptible(o2media_timerint_event,o2media_timerint);
}
BOOLEAN o2media_check_intrflags(void)
{
	BOOLEAN ret;
	unsigned long flags;
	spin_lock_irqsave(&o2media_intr_lock,flags);
	if(o2media_intr_comming==1)
		ret = TRUE;
	else
		ret = FALSE;
	spin_unlock_irqrestore(&o2media_intr_lock,flags);
	return ret;
}
void o2media_clear_intrflags(void)
{
	unsigned long flags;
		spin_lock_irqsave(&o2media_intr_lock,flags);
		if(o2media_intr_comming==0)
			printk("error: clear intrflags but it is not setted\n");
		else
			o2media_intr_comming = 0;
		spin_unlock_irqrestore(&o2media_intr_lock,flags);
}
void o2media_clear_timerint(void)
{
	unsigned long flags;
		spin_lock_irqsave(&o2media_timerint_lock,flags);
		if(o2media_timerint==0)
			printk("error: clear timerint but it is not setted\n");
		else
			o2media_timerint = 0;
		spin_unlock_irqrestore(&o2media_timerint_lock,flags);
}
void o2media_set_intrflags(void)
{
	unsigned long flags;
		spin_lock_irqsave(&o2media_intr_lock,flags);
		if(o2media_intr_comming==1)
			printk("error: set intrflags but it is setted\n");
		else
		{
			o2media_intr_comming = 1;
			wake_up_interruptible(&o2media_Event);
		}
		spin_unlock_irqrestore(&o2media_intr_lock,flags);
}
void o2media_set_timerint(void)
{
	unsigned long flags;
		spin_lock_irqsave(&o2media_timerint_lock,flags);
		if(o2media_timerint==1)
			printk("error: set timerint but it is already setted\n");
		else
		{
			o2media_timerint = 1;
			wake_up_interruptible(&o2media_timerint_event);
		}
		spin_unlock_irqrestore(&o2media_timerint_lock,flags);
}
void o2media_complete_and_exit(void)
{
	complete_and_exit(&ko2media_exited,0);
}

void o2media_wait_for_completion(void)
{
	wait_for_completion(&ko2media_exited);
}
#if LINUX_VERSION_CODE <  KERNEL_VERSION(2,4,0)
static struct wait_queue *o2sd_Event = NULL;
#else
DECLARE_WAIT_QUEUE_HEAD(o2sd_Event);
#endif
static spinlock_t o2sd_intr_lock = SPIN_LOCK_UNLOCKED;
static UCHAR o2sd_intr_comming = 0;

// index 0 used for command wait complete
// index 1 used for read buffer ready wait complate
// index 2 used for write buffer ready wait complete
static DECLARE_COMPLETION(ko2sd_exited);
void o2sd_wait_event_interruptible(void)
{
	wait_event_interruptible(o2sd_Event,o2sd_intr_comming);
}
BOOLEAN o2sd_check_intrflags(void)
{
	BOOLEAN ret;
	unsigned long flags;
	spin_lock_irqsave(&o2sd_intr_lock,flags);
	if(o2sd_intr_comming==1)
		ret = TRUE;
	else
		ret = FALSE;
	spin_unlock_irqrestore(&o2sd_intr_lock,flags);
	return ret;
}
void o2sd_clear_intrflags(void)
{
	unsigned long flags;
		spin_lock_irqsave(&o2sd_intr_lock,flags);
		o2sd_intr_comming = 0;
		spin_unlock_irqrestore(&o2sd_intr_lock,flags);
}
void o2sd_set_intrflags(void)
{
	unsigned long flags;
		spin_lock_irqsave(&o2sd_intr_lock,flags);
		o2sd_intr_comming = 1;
		wake_up_interruptible(&o2sd_Event);
		spin_unlock_irqrestore(&o2sd_intr_lock,flags);
}
void o2sd_complete_and_exit(void)
{
	complete_and_exit(&ko2sd_exited,0);
}

void o2sd_wait_for_completion(void)
{
	wait_for_completion(&ko2sd_exited);
}
BOOLEAN winif_signal_pending_current(void)
{
	return signal_pending(current);
}

int winif_kernel_thread(PVOID StartRoutine,PVOID StartContext)
{
	return kernel_thread(StartRoutine,StartContext,0);
}
void winif_kill_proc(int pid,int sig)
{
	if(sig!=0)
	kill_proc(pid,sig,1);
	else
	kill_proc(pid,SIGKILL,1);
}
void winif_strncpy(char* to, const char* from, int length)
{
	strncpy(to,from,length);
}
void winif_memcpy(PVOID to ,PVOID from,int length)
{
	memcpy(to,from,length);
}

void RtlZeroMemory(PVOID des,int length)
{
	memset(des,0,length);
}
void	RtlFillMemory(PVOID des,int length, int data)
{
	memset(des,data,length);
}


void RtlCopyMemory(UCHAR* to,UCHAR* from,int length)
{
	memcpy(to,from,length);
}

static int getorderfrompages(unsigned long pages)
{
	int order;
	for(order = 1;order<MAX_ORDER;order++)
	{
		if( (1 << order) < pages)
			continue;
		else
			return order;
	}
	printk("alloc more than 512 pages can not support\n");
	return -1;
}

// we can not use kmalloc for size bigger than 128k, use __get_free_pages instead.
void*  ExAllocatePool(BOOLEAN f_atomic,ULONG size)
{
	void* x;
	unsigned long ret;
	int order;
	int pages;
	int i;
	if(size>1024*128)
	{
//		printk("size is bigger than 1024*128\n");
		i = ((size%PAGE_SIZE) > 0)?1:0;
		pages = (unsigned int)(size/PAGE_SIZE)+i;
		order = getorderfrompages(pages);
	//	printk("order is %d\n",order);
		if(order<0)return NULL;
	if(f_atomic==TRUE)
		{
			ret = __get_free_pages(GFP_ATOMIC,order);
			if(!ret)
			{
				printk("get free pages %x order %d atomic failed\n",size,order);
				return (void*)ret;
			}
			memset((void*)ret,0,PAGE_SIZE<<order);
		}
	else 
		{
		//	ret = __get_free_pages(GFP_KERNEL,order);
			ret = vmalloc(PAGE_SIZE<<order);
			if(!ret)
			{
				printk("get free pages %x order %d failed\n",size,order);
				return (void*)ret;
			}
			memset((void*)ret,0,PAGE_SIZE<<order);
		}
	//	printk("alloc %d pages at %x\n",pages,ret);
		return (void*)ret;
	}
	else
	{
	//	printk("size is little than 1024*128\n");
		if(f_atomic==TRUE)
		{
			x = kmalloc(size,GFP_ATOMIC);
			if(x)
			;//	printk("kmalloc %x size at %x ok\n",size,x);
			else
				printk("kmalloc %x size atomic failed\n",size);
			memset(x,0,size);
		}
		else 
		{
			x = kmalloc(size,GFP_KERNEL);
			if(x)
			;//	printk("kmalloc %x size at %x ok\n",size,x);
			else
				printk("kmalloc %x size failed\n",size);
			memset(x,0,size);
		}
		return x;
	}

}

void ExFreePool(PVOID ptr,unsigned long size)
{
	int order;
	int pages;
	int i;
	if(size>1024*128)
	{
		i = ((size%PAGE_SIZE) > 0)?1:0;
		pages = (unsigned int)(size/PAGE_SIZE)+i;
		order = getorderfrompages(pages);
	//	free_pages((unsigned long)ptr,order);
		vfree(ptr);
	//	printk("free %d pages at %x ok\n",pages,ptr);
	}
	else
		kfree(ptr);
}

